;;;
;;; ACHTUNG: Diese Programm funktioniert nur einwandfrei, wenn WKS aktiv und die Polylinie koplanar zum WKS ist !
;;;	     Benutzung auf eigene Gefahr !
;;;
;;;**********************************************************************
;;;* ISO-Datei von PLINE erstellen   					*
;;;**********************************************************************
(defun c:pl2iso (/               col             curve-obj       dxf             ent             firstseg_list
                 givenpnt        lastseg_list    midpara         new_seg_list    para            pnt
                 revseg_list     seg_list        temp-ename      absolut         file            filename
                 nclist          offsetdir       refpt           n
                 ;; Funktionen
                 //vv            2p->vektor      <urv            ==              ===             ===point
                 ==point         add_vertex_seg_list             arc2bulge       assoc2seg_list  draw_seg_list
                 draw_vtx_list   enderrorhandler entmod*         entmod_pline    getpoint=       get_assoc_list
                 get_cen_seg     get_vtx_list    is_closed_seg_list              is_offset_right is_point_on_seg
                 new_start_seg_list              pliso:defun     plusp           reverse_seg_list
                 seg2cir         seg2vtx_list    seg_list2nc     starterrorhandler               tan
                 <vv             get_arrow_left_seg              get_arrow_right_seg             grdraw*side
                 ortholinks      orthorechts     seg2vektor      pliso:cleanup
                )
  (pliso:defunlibrary)
  ;; Errorhandler
  (starterrorhandler "c:pl2iso"               'nil                     '(("cmdecho" . 0) ("dimzin" . 9))
                     'nil                     'pliso:cleanup           'pliso:cleanup
                    )
  (vl-load-com)
  (command "_redraw")
  ;; Pline whlen + prfen etc.
  (and
    (if (not (equal '(1.0 1.0 1.0) (trans '(1.0 1.0 1.0) 1 0)))
      (alert
        "Es ist ein Benutzerkoordinatensystem (BKS) aktiv !\nDieses Programm arbeitet jedoch nur im WKS.\n -> bitte auf WKS umschalten und neu aufrufen !"
      )
      't
    )
    (setq ent (car (entsel "\nLWPOLYLINE whlen:")))
    (setq dxf (entget ent))
    (if (not (equal '(0.0 0.0 1.0) (cdr (assoc 210 dxf)) 1e-8))
      (alert "Gewhltes Objekt ist nicht parallel zum WKS !")
      't
    )
    (if (/= "LWPOLYLINE" (cdr (assoc 0 dxf)))
      (alert "Gewhltes Objekt ist keine LWPOLYLINE !")
      't
    )
    (setq curve-obj (vlax-ename->vla-object ent))
    (setq col (vlax-get-property curve-obj 'color))
    ;; Segmentliste bilden
    (setq seg_list (assoc2seg_list dxf))
    ;; Geschlossen ? 'T -> Startpunkt abfragen / 'nil -> weiter mit Laufrichtung
    (is_closed_seg_list seg_list)
    ;; Dann neuen Startpunkt...
    (setq pnt (trans (getpoint "\nErsten Konturpunkt whlen: ") 1 0))
    (setq seg_list (new_start_seg_list seg_list pnt))
    ;; ...wenn dieser auf Pline liegt...
    (if (vlax-curve-getparamatpoint curve-obj pnt)
      ;; ...ndern
      (entmod_pline dxf seg_list)
      (progn (alert "Gewhlter Punkt liegt nicht auf Polylinie ")
             ;; seg_list -> nil damit keine Laufrichtung abgefragt wird
             (setq seg_list nil)
      )
    )
  ) ;and
  ;; Laufrichtung abfragen wenn seg_list vorhanden (auch offene Konturen)
  (and seg_list
       (setq firstseg_list (list (car seg_list))
             lastseg_list  (list (last seg_list))
             revseg_list   (reverse_seg_list seg_list)
       )
       ;; 'dickes Segment zeichnen
       (setq temp-ename (draw_seg_list firstseg_list
                                       (vla-get-Layer curve-obj)
                                       col
                                       (/ (getvar "VIEWSIZE") 150)
                        )
       )
       (princ "\nErstes Konturelement (Richtung) whlen: ")
       ;; Parameter von Plinemitte
       (setq midpara (vlax-curve-getparamatdist
                       curve-obj
                       (* 0.5 (vlax-curve-getdistatparam curve-obj (vlax-curve-getendparam curve-obj)))
                     )
       )
       ;; Laufrichtung abfragen mit grread
       (while (= 5 (car (setq givenpnt (grread t))))
         ;; Grread-Punkt auf Pline projezieren
         (setq givenpnt (trans (cadr givenpnt) 1 0)
               para     (vlax-curve-getparamatpoint
                          curve-obj
                          (vlax-curve-getclosestpointto curve-obj givenpnt)
                        )
         )
         ;; Statuszeile update
         (grtext -2 (rtos para 2 3))
         ;; 'dickes Segment' anpassen...
         ;; ... ->  Linienbreite anpassen an Zoomfaktor...
         (entmod* temp-ename 43 (/ (getvar "VIEWSIZE") 150))
         ;; ... -> Position anpassen an Laufrichtung
         (if (<= para midpara)
           ;; Wenn Parameter in 1. Hlfte
           (progn (setq new_seg_list seg_list) (entmod_pline temp-ename firstseg_list))
           ;; Wenn Parameter in 2. Hlfte
           (progn (setq new_seg_list revseg_list) (entmod_pline temp-ename lastseg_list))
         )
       ) ;while
  ) ;and
  ;; Laufrichtung ndern + NC-Ausgabe, wenn new_seg_list erstellt wurde
  (and new_seg_list
       (entmod_pline dxf new_seg_list)
       (setq refpt (trans (getpoint= "Nullpunkt whlen: " '(0.0 0.0)) 1 0))
       (progn (setq offsetdir (if (is_offset_right ent
                                                   3.0 ;Pfeilgre
                                                   "\nBahnkorrekturseite zeigen (siehe Statuszeile): "
                                  )
                                "G42"
                                "G41"
                              )
              )
              (princ (strcat "\nBahnkorrektur "
                             offsetdir
                             (if (= offsetdir "G41")
                               " LINKS"
                               " RESCHTS"
                             )
                     )
              )
              (initget "Absolut Inkremental")
              (setq absolut (if (= "Absolut"
                                   (getkword "\nKreismittelpunkt Absolut oder Inkremental (A/I) <Inkremental>:")
                                )
                              't
                              'nil
                            )
              )
              (princ (strcat "Kreismittelpunkte werden "
                             (if absolut
                               "absolut"
                               "inkremental"
                             )
                             " ausgegeben."
                     )
              )
              't
       )
       (setq filename (getfiled "ISO-Datei speichern unter:" "" "ISO" (+ 1 4)))
       ;; NC-Code (nur Geometrie) holen...
       (setq nclist (seg_list2nc new_seg_list offsetdir "G40" refpt 3 "X" "Y" "I" "J" "G1" "G2" "G3" absolut)
       )
       ;; ...und in Datei schreiben
       (setq file (open filename "W"))
       (setq n 10)
       (foreach line nclist
         ;; Satznummer nicht vergessen !
         (write-line (strcat "N" (itoa n) " " line) file)
         (setq n (1+ n))
       )
       (princ (strcat "\n" filename " gespeichert."))
  ) ;and
  (enderrorhandler)
  (princ)
)

(princ "\nPline2ISO geladen.\nAufruf mit PL2ISO")
;;;******************************************************************************************************
;;; Libraryfunktionen fr PlineStart.LSP
;;;******************************************************************************************************
(defun pliso:defunlibrary ()
;;; Aufrumen
  (defun pliso:cleanup ()
    (if file
      (close file)
    )
    (if temp-ename
      (entdel temp-ename)
    )
    (redraw)
  )
;;; Allgemeine_Funktionen.LSP
  (defun get_assoc_list (ent)
    (if (listp ent)
      (if (= (type (car ent)) (quote ename))
        (entget (car ent))
        ent
      )
      (entget ent)
    )
  )
  (defun entmod* (ent dxf wert)
    (setq ent (get_assoc_list ent))
    (if (assoc dxf ent)
      (entmod (subst (cons dxf wert) (assoc dxf ent) ent))
      (entmod (append ent (list (cons dxf wert))))
    )
  )
;;; Input_Funktionen.lsp
  (defun getpoint= (anfrage vorgabe)
    (initget 0)
    (cond ((getpoint
             (strcat "\n"
                     anfrage
                     " <"
                     (apply (quote strcat)
                            (mapcar (quote (lambda (axis zahl) (strcat axis (rtos zahl 2 (getvar "LUPREC")))))
                                    (quote ("X" " Y" " Z"))
                                    vorgabe
                            )
                     )
                     ">: "
             )
           )
          )
          ('t (mapcar (quote float) vorgabe))
    )
  )
;;; mathematische_Funktionen.LSP
  (defun <vv (v1 v2 / ang)
    (setq ang (- (<urv v2) (<urv v1)))
    (cond ((=== 0.0 ang) 0.0)
          ((=== pi ang) pi)
          ((> ang pi) (- ang (* 2 pi)))
          ((<= ang (- pi)) (+ ang (* 2 pi)))
          (t (eval ang))
    )
  )
  (defun ortholinks (vektor) (reverse (mapcar (quote *) vektor (quote (1 -1)))))
  (defun orthorechts (vektor) (reverse (mapcar (quote *) vektor (quote (-1 1)))))
  (defun tan (z / cosz)
    (cond ((zerop (rem z pi)) 0.0)
          ((zerop (rem z (/ pi 2.0))) 1.7e308)
          ((zerop (setq cosz (cos z))) 1.7e308)
          (t (/ (sin z) cosz))
    )
  )
  (defun plusp (zahl) (not (minusp zahl)))
  (defun == (zahl1 zahl2)
    (if (equal zahl1 zahl2 1.0e-015)
      t
      nil
    )
  )
  (defun === (zahl1 zahl2)
    (if (equal zahl1 zahl2 1.0e-6)
      t
      nil
    )
  )
  (defun <urv (v1 / ang) ; Winkel zwischen Ursprung und Vektor 0 >= ergebnis < 2pi
    (if (not (zerop (car v1)))
      (setq ang (abs (atan (/ (* 1.0 (cadr v1)) (car v1))))) ;* 1.0 um integer zu eliminieren
    )
    (cond ((=== (cadr v1) 0.0)
           (if (minusp (car v1))
             pi
             ;;-> 180 deg
             0.0
           )
          ) ;-> 0 deg
          ((== (car v1) 0.0)
           (if (minusp (cadr v1))
             (* pi 1.5) ;-> 270 deg
             (/ pi 2.0)
           )
          ) ;-> 90 deg
          ((minusp (car v1))
           (if (minusp (cadr v1))
             (+ pi ang) ;-> 3. Quadrant
             (- pi ang)
           )
          ) ;->2. Quadrant
          ((plusp (car v1))
           (if (minusp (cadr v1))
             (- (* pi 2.0) ang) ;-> 4.Quadrant
             ang
           )
          ) ;-> 1.Quadrant
          (t (princ "\nWinkel nicht definiert Funktion '<urv' ") nil)
    )
  )
  (defun 2p->vektor (start end) (mapcar (quote -) end start))
  (defun //vv (v1 v2 /) (=== (<urv v1) (<urv v2)))
  (defun ===point (p1 p2)
    (and (= (length p1) (length p2)) (apply (quote and) (mapcar (quote ===) p1 p2)))
  )
  (defun ==point (p1 p2)
    (and (= (length p1) (length p2)) (apply (quote and) (mapcar (quote ==) p1 p2)))
  )
;;; polylinien_funktionen.LSP
  (defun seg_list2nc (seg_list offset_start offset_ende nullp dez /x /y /i /j /g1 /g2 /g3 absolut)
    (vl-remove ""
               (append (list (strcat offset_start
                                     " "
                                     /x
                                     (rtos (- (caar (car seg_list)) (car nullp)) 2 dez)
                                     " "
                                     /y
                                     (rtos (- (cadar (car seg_list)) (cadr nullp)) 2 dez)
                             )
                       )
                       (mapcar (quote (lambda (seg / cen)
                                        (setq cen (get_cen_seg seg))
                                        (strcat (if (zerop (last seg))
                                                  (strcat /g1
                                                          " "
                                                          /x
                                                          (rtos (- (caadr seg) (car nullp)) 2 dez)
                                                          " "
                                                          /y
                                                          (rtos (- (cadadr seg) (cadr nullp)) 2 dez)
                                                  )
                                                  (strcat (if (minusp (last seg))
                                                            /g2
                                                            /g3
                                                          )
                                                          " "
                                                          /x
                                                          (rtos (- (caadr seg) (car nullp)) 2 dez)
                                                          " "
                                                          /y
                                                          (rtos (- (cadadr seg) (cadr nullp)) 2 dez)
                                                          " "
                                                          /i
                                                          (rtos (- (car cen)
                                                                   (if absolut
                                                                     (car nullp)
                                                                     (caar seg)
                                                                   )
                                                                )
                                                                2
                                                                dez
                                                          )
                                                          " "
                                                          /j
                                                          (rtos (- (cadr cen)
                                                                   (if absolut
                                                                     (cadr nullp)
                                                                     (cadar seg)
                                                                   )
                                                                )
                                                                2
                                                                dez
                                                          )
                                                  )
                                                )
                                        )
                                      )
                               )
                               seg_list
                       )
                       (list offset_ende)
               )
    )
  )
  (defun grdraw*side (pfeil color /)
    (grdraw (car pfeil) (cadr pfeil) color)
    (grdraw (cadr pfeil) (caddr pfeil) color)
    (grdraw (cadr pfeil) (cadddr pfeil) color)
  )
  (defun get_arrow_left_seg (seg len / p1 p2 p3 p4 ang vstart)
    (setq vstart (car (seg2vektor seg))
          p1     (car seg)
          ang    (angle (quote (0 0 0)) vstart)
          p2     (polar p1 (+ ang (* 0.5 pi)) len)
          p3     (polar p2 (- ang 1.05) (* len 0.3))
          p4     (polar p2 (+ ang 4.2) (* len 0.3))
    )
    (mapcar (quote (lambda (pu) (trans pu 0 1))) (list p1 p2 p3 p4))
  )
  (defun get_arrow_right_seg (seg len / p1 p2 p3 p4 ang vstart)
    (setq vstart (car (seg2vektor seg))
          p1     (car seg)
          ang    (angle (quote (0 0 0)) vstart)
          p2     (polar p1 (- ang (* 0.5 pi)) len)
          p3     (polar p2 (- ang 4.2) (* len 0.3))
          p4     (polar p2 (+ ang 1.05) (* len 0.3))
    )
    (mapcar (quote (lambda (pu) (trans pu 0 1))) (list p1 p2 p3 p4))
  )
  (defun seg2vektor (seg / cen start end mid)
    (cond ((= 0.0 (last seg)) (list (2p->vektor (car seg) (cadr seg))))
          (t
           (setq cen   (get_cen_seg seg)
                 start (if (minusp (last seg))
                         (orthorechts (2p->vektor cen (car seg)))
                         (ortholinks (2p->vektor cen (car seg)))
                       )
                 end   (if (minusp (last seg))
                         (orthorechts (2p->vektor cen (cadr seg)))
                         (ortholinks (2p->vektor cen (cadr seg)))
                       )
                 mid   (2p->vektor (car seg) (cadr seg))
           )
           (list start mid end)
          )
    )
  )
  (defun is_offset_right (ename          dist           anfrage        /              closestpnt     closestpoint
                          curve-obj      firstderiv     givenpnt       lastside       newside        pfeil_list_links
                          pfeil_list_rechts             seg            seg_list
                         )
    (princ anfrage)
    (setq seg_list          (assoc2seg_list ename)
          curve-obj         (vlax-ename->vla-object ename)
          pfeil_list_rechts (mapcar (quote (lambda (seg) (get_arrow_right_seg seg dist))) seg_list)
          pfeil_list_links  (mapcar (quote (lambda (seg) (get_arrow_left_seg seg dist))) seg_list)
          lastside          "dummy"
    )
    (while (= 5 (car (setq givenpnt (grread t))))
      (setq givenpnt   (trans (cadr givenpnt) 1 0)
            closestpnt (vlax-curve-getclosestpointto curve-obj givenpnt)
            firstderiv (vlax-curve-getfirstderiv
                         curve-obj
                         (vlax-curve-getparamatpoint curve-obj closestpnt)
                       )
            newside    (minusp (<vv firstderiv (2p->vektor closestpnt givenpnt)))
      )
      (cond ((= newside lastside))
            (newside (redraw) (foreach pfeil pfeil_list_rechts (grdraw*side pfeil 20)))
            (t (redraw) (foreach pfeil pfeil_list_links (grdraw*side pfeil 20)))
      )
      (setq lastside newside)
      (grtext -2
              (if lastside
                "RECHTS"
                "LINKS"
              )
      )
    )
    (redraw)
    lastside
  )
  (defun draw_vtx_list (vtx_list lay col wid /)
    (entmake (append (quote ((0 . "LWPOLYLINE")))
                     (list (cons 8 lay))
                     (quote ((100 . "AcDbEntity")))
                     (quote ((100 . "AcDbPolyline")))
                     (list (cons 43 wid))
                     (list (cons 62 col))
                     vtx_list
             )
    )
  )
  (defun draw_seg_list (seg_list lay col wid /)
    (draw_vtx_list (seg2vtx_list seg_list) lay col wid)
    (entlast)
  )
  (defun reverse_seg_list (seg_list)
    (reverse
      (mapcar (quote (lambda (seg) (list (cadr seg) (car seg) (- (last seg)))))
              seg_list
      )
    )
  )
  (defun seg2vtx_list (seg_list / num vtx_list)
    (mapcar (function
              (lambda (x)
                (setq vtx_list (append vtx_list (list (cons 10 (car x))) (list (cons 42 (caddr x)))))
              )
            )
            seg_list
    )
    (if (not (is_closed_seg_list seg_list))
      (setq vtx_list (append vtx_list (list (cons 10 (cadr (last seg_list)))) (list (cons 42 0))))
    )
    (cons (cons 90 (/ (length vtx_list) 2))
          (if (is_closed_seg_list seg_list)
            (cons (quote (70 . 1)) vtx_list)
            (cons (quote (70 . 0)) vtx_list)
          )
    )
  )
  (defun entmod_pline (lwpl seg_list / part1)
    (setq lwpl (get_assoc_list lwpl))
    (if (= "LWPOLYLINE" (cdr (assoc 0 lwpl)))
      (entmod (append (vl-remove-if (quote (lambda (item)
                                             (or (= 10 (car item))
                                                 (= 40 (car item))
                                                 (= 41 (car item))
                                                 (= 42 (car item))
                                                 (= 70 (car item))
                                                 (= 90 (car item))
                                             )
                                           )
                                    )
                                    lwpl
                      )
                      (seg2vtx_list seg_list)
              )
      )
    )
  )
  (defun arc2bulge (p1 p2 cen cw / start end)
    (setq start (angle cen p1)
          end   (angle cen p2)
    )
    (tan (* 0.25
            (if (if (numberp cw)
                  (minusp cw)
                  cw
                )
              (if (> start end)
                (- end start)
                (- end start (* pi 2.0))
              )
              (if (> start end)
                (+ (- (* pi 2.0) start) end)
                (- end start)
              )
            )
         )
    )
  )
  (defun get_cen_seg (seg / p1 p2 cot)
    (if (not (zerop (last seg)))
      (progn (setq p1  (car seg)
                   p2  (cadr seg)
                   cot (* 0.5 (- (/ 1.0 (last seg)) (last seg)))
             )
             (list (/ (- (+ (car p1) (car p2)) (* (- (cadr p2) (cadr p1)) cot)) 2.0)
                   (/ (+ (+ (cadr p1) (cadr p2)) (* (- (car p2) (car p1)) cot)) 2.0)
             )
      )
    )
  )
  (defun seg2cir (seg / bulge p1 p2 cot x y rad dummy)
    (if (zerop (caddr seg))
      nil
      (setq p1    (car seg)
            p2    (cadr seg)
            bulge (caddr seg)
            cot   (* 0.5 (- (/ 1.0 bulge) bulge))
            x     (/ (- (+ (car p1) (car p2)) (* (- (cadr p2) (cadr p1)) cot)) 2.0)
            y     (/ (+ (+ (cadr p1) (cadr p2)) (* (- (car p2) (car p1)) cot)) 2.0)
            rad   (distance (list (car p1) (cadr p1)) (list x y))
            dummy (list (list x y) rad)
      )
    )
  )
  (defun is_point_on_seg (seg point / cir cen start end winkel)
    (cond ((or (===point (car seg) point) (===point (cadr seg) point)))
          ((zerop (last seg))
           (and (//vv (2p->vektor (car seg) (cadr seg)) (2p->vektor (car seg) point))
                (< (distance (car seg) point) (distance (car seg) (cadr seg)))
           )
          )
          (t
           (setq cir (seg2cir seg)
                 cen (car cir)
           )
           (if (=== (cadr cir) (distance point cen))
             (progn (if (minusp (last seg))
                      (setq start (<urv (2p->vektor cen (cadr seg)))
                            end   (<urv (2p->vektor cen (car seg)))
                      )
                      (setq start (<urv (2p->vektor cen (car seg)))
                            end   (<urv (2p->vektor cen (cadr seg)))
                      )
                    )
                    (setq winkel (<urv (2p->vektor cen point)))
                    (if (< start end)
                      (< start winkel end)
                      (or (< start winkel) (< winkel end))
                    )
             )
           )
          )
    )
  )
  (defun add_vertex_seg_list (seg_list point / cen)
    (setq point (list (car point) (cadr point)))
    (cond ((not seg_list) nil)
          ((or (===point (caar seg_list) point) (===point (cadar seg_list) point))
           seg_list
          )
          ((is_point_on_seg (car seg_list) point)
           (append (if (zerop (caddar seg_list))
                     (list (list (caar seg_list) point 0.0) (list point (cadar seg_list) 0.0))
                     (progn (setq cen (get_cen_seg (car seg_list)))
                            (list (list (caar seg_list)
                                        point
                                        (arc2bulge (caar seg_list) point cen (caddar seg_list))
                                  )
                                  (list point
                                        (cadar seg_list)
                                        (arc2bulge point (cadar seg_list) cen (caddar seg_list))
                                  )
                            )
                     )
                   )
                   (cdr seg_list)
           )
          )
          (t (append (list (car seg_list)) (add_vertex_seg_list (cdr seg_list) point)))
    )
  )
  (defun new_start_seg_list (seg_list point / start)
    (setq point (list (car point) (cadr point)))
    (cond ((not (is_closed_seg_list seg_list))
           (if (===point (cadr (last seg_list)) point)
             (reverse_seg_list seg_list)
             seg_list
           )
          )
          ((setq start (vl-member-if (quote (lambda (seg) (===point (car seg) point)))
                                     (setq seg_list (add_vertex_seg_list seg_list point))
                       )
           )
           (append start (reverse (cdr (member (car start) (reverse seg_list)))))
          )
          (t seg_list)
    )
  )
  (defun is_closed_seg_list (seg_list /)
    (==point (caar seg_list) (cadr (last seg_list)))
  )
  (defun get_vtx_list (ele / vtx_list)
    (foreach n ele
      (if (or (= 10 (car n)) (= 42 (car n)))
        (setq vtx_list (append vtx_list (list n)))
      )
    )
    vtx_list
  )
  (defun assoc2seg_list (ele / seg_list vtx_list vtx_nr1 vtx vtx2)
    (setq ele (get_assoc_list ele))
    (setq vtx_list (get_vtx_list ele))
    (setq vtx_nr1 (assoc 10 vtx_list))
    (while (setq vtx (assoc 10 vtx_list))
      (setq vtx_list (member (assoc 10 vtx_list) vtx_list))
      (setq vtx_list (cdr vtx_list))
      (if (setq vtx2 (assoc 10 vtx_list))
        (setq seg_list (append seg_list (list (list (cdr vtx) (cdr vtx2) (cdr (assoc 42 vtx_list))))))
        (if (not (zerop (logand 1 (cdr (assoc 70 ele)))))
          (setq seg_list (append seg_list
                                 (list (list (cdr vtx) (cdr vtx_nr1) (cdr (assoc 42 vtx_list))))
                         )
          )
        )
      )
    )
    seg_list
  )
;;; Errorhandler.lsp
;;; Quelle: 
;;;Februar 2004
;;;In Zusammenarbeit mit diversen CAD.DE Membern entstanden
;;;
;;;Besonderer Dank an MAPCAR (http://www.autolisp.mapcar.net) fr den Basis-Error-Handler
;;;und all die netten Informationen ber die netten Lisp-Interna :-).
  (defun enderrorhandler (/) (*error* nil))
  (defun starterrorhandler (name undomode varstosave on-start on-good on-bad / errortemplate savelist instance o_cmdecho)
    (setq
      errortemplate (quote
                      ((msg / name undo savedvars previoushandler instance on-start on-good on-bad)
                        (while (> (getvar "cmdactive") 0) (command))
                        (if (= instance 1)
                          (progn (command "_undo" "_end")
                                 (if (and undo msg)
                                   (command "_u")
                                 )
                          )
                        )
                        (foreach pair savedvars
                          (setvar (car pair) (cdr pair))
                          (if (and msg *verbose*)
                            (progn (princ
                                     (strcat "\n" name "(" (itoa instance) "): Setze \"" (car pair) "\" zurck auf ")
                                   )
                                   (princ (cdr pair))
                            )
                          )
                        )
                        (if msg
                          (progn (if (and (= instance 1) *verbose*)
                                   (princ (strcat "\nError:" name "(" (itoa instance) "): \"" msg "\""))
                                 )
                                 (if on-bad
                                   ((eval on-bad))
                                 )
                          )
                          (if on-good
                            ((eval on-good))
                          )
                        )
                        (setq *error* previoushandler)
                        (if (= instance 1)
                          (princ)
                          (*error* msg)
                        )
                      )
                    )
    )
    (setq instance (if (or (= (type *error*) (quote subr)) (null *error*))
                     1
                     (1+ (caddr (cadr *error*)))
                   )
    )
    (if (= instance 1)
      (progn (setq o_cmdecho (getvar "cmdecho"))
             (setvar "cmdecho" 0)
             (command "_undo" "_begin")
             (setvar "cmdecho" o_cmdecho)
      )
    )
    (foreach pair varstosave
      (setq savelist (cons (cons (car pair) (getvar (car pair))) savelist))
      (setvar (car pair) (cdr pair))
    )
    (if on-start
      ((eval on-start))
    )
    (setq *error* (append (list (car errortemplate))
                          (list (list (quote setq) (quote instance) instance))
                          (if undomode
                            (quote ((setq undo (quote t))))
                            (quote ((setq undo nil)))
                          )
                          (list
                            (list (quote setq) (quote previoushandler) (cons (quote quote) (list *error*)))
                          )
                          (list (list (quote setq) (quote name) name))
                          (list (cons (quote setq)
                                      (cons (quote savedvars) (list (cons (quote quote) (list savelist))))
                                )
                          )
                          (list (list (quote setq) (quote on-start) on-start))
                          (list (list (quote setq) (quote on-good) on-good))
                          (list (list (quote setq) (quote on-bad) on-bad))
                          (cdr errortemplate)
                  )
    )
    (princ)
  )
)

 ;|Visual LISP Format Options
(120 2 1 2 nil "Ende von " 80 20 1 1 0 nil nil nil T)
;*** KEINEN Text unterhalb des Kommentars hinzufgen! ***|;
